
	section	.data
	align	1
_veclogger
	dc.w	_veclog
	align	1
_speedlogger
	dc.w	_speedlog

	section	.text
	align	1

	global	_windgust
_windgust
	pshm	z
	tsz

	clrd	
	ldy	#_speedlog

L2	cpd	0,y
	bhs	L4
	
	ldd	0,y

L4	xgdy	
	addd	#2
	xgdy	
	cpy	#_speedlog+60
	blo	L2
	
	pulm	z
	rts

	align	1

	global	_windspeed
_windspeed
	pshm	z
	ais	#-2
	tsz

	clre	
	ldy	_speedlogger
	ldab	#6
	stab	0,z

L8	xgdy	
	addd	#-2
	xgdy	
	cpy	#_speedlog
	bhs	L11
	
	ldy	#_speedlog+58

L11	adde	0,y
	dec	0,z
	bne	L8
	
	ldx	#6
	ted	
	idiv	
	txd	

	ais	#+2
	pulm	z
	rts

	align	1

	global	_winddir
_winddir
	pshm	z
	ais	#-12
	tsz

	clrw	4,z
	clrw	6,z
	clrw	8,z
	clrw	10,z
	ldy	#_veclog

L14	ldd	2+4,z
	addd	2+0,y
	std	2+4,z
	ldd	0+4,z
	adcb	1+0,y
	adca	0+0,y
	std	0+4,z
	ldd	2+8,z
	addd	2+4,y
	std	2+8,z
	ldd	0+8,z
	adcb	1+4,y
	adca	0+4,y
	std	0+8,z
	xgdy	
	addd	#8
	xgdy	
	cpy	#_veclog+48
	blo	L14
	
	ldx	8,z
	stx	0,z
	ldx	10,z
	stx	2,z
	lde	4,z
	ldd	6,z
	jsr	_iatan2

	ais	#+12
	pulm	z
	rts

	align	1

	global	_relative_humidity
_relative_humidity
	pshm	z
	ais	#-6
	tsz

	jsr	_read_AN7
	std	2,z
	jsr	_ow_celsius
	tdy	
	cpy	#-50
	bge	L19
	
	ldy	#-50
	bra	L20
	

L19	cpy	#100
	ble	L20
	
	ldy	#100

L20	lde	2,z
	cpe	#10485
	bls	L22
	
	aie	#-10486
	ste	2,z
	bra	L23
	

L22	clrw	2,z

L23	tyd	
	lde	#70
	emuls	
	std	4,z
	ldy	#-30979
	xgey	
	sde	
	xgey	
	sty	0,z
	lde	2,z
	ldd	#16129
	jsr	_muldiv
	std	2,z
	lde	2,z
	aie	#100
	ste	2,z
	ldx	#200
	ldd	2,z
	idiv	
	cpx	#100
	bls	L24
	
	ldx	#100

L24	txd	

	ais	#+6
	pulm	z
	rts

	align	1
_jorgio
	pshm	z
	ais	#-12
	tsz

	std	0,z
	bne	L26
	
	ldd	#1
	std	0,z

L26	clr	2,z
	cpe	#179
	bls	L28
	
	ldab	#1
	stab	2,z

L28	tst	2,z
	beq	L27
	
	aie	#-180

L27	jsr	_eight_bit_sin_from_abs_degrees
	lde	0,z
	jsr	_EMUL
	ste	4,z
	std	6,z
	tst	2,z
	bne	L29
	
	lde	4,z
	ldd	6,z
	bra	L30
	

L29	lde	4,z
	ldd	6,z
	jsr	_lnegate
	ste	8,z
	std	10,z
	lde	8,z
	ldd	10,z

L30
	ais	#+12
	pulm	z
	rts

	align	1
_log_wind_sample
	pshm	z
	ais	#-12
	tsz

	ste	0,z
	std	2,z
	jsr	_jorgio
	ste	4,z
	std	6,z
	ldd	0,z
	aid	#90
	std	0,z
	cpd	#359
	bls	L32
	
	aid	#-360
	std	0,z

L32	lde	0,z
	ldd	2,z
	jsr	_jorgio
	ste	8,z
	std	10,z
	jsr	_hold_txproc
	ldy	_veclogger
	ldd	4,z
	std	0,y
	ldd	6,z
	std	2,y
	ldd	8,z
	std	4,y
	ldd	10,z
	std	6,y
	xgdy	
	addd	#8
	xgdy	
	sty	_veclogger
	cpy	#_veclog+48
	blo	L33
	
	ldd	#_veclog
	std	_veclogger

L33	ldy	_speedlogger
	ldd	18,z
	std	0,y
	lde	_speedlogger
	aie	#2
	ste	_speedlogger
	cpe	#_speedlog+60
	blo	L34
	
	ldd	#_speedlog
	std	_speedlogger

L34	jsr	_okay_txproc

	ais	#+12
	pulm	z
	rts

	align	1
_mph_to_knots
	pshm	z
	ais	#-2
	tsz

	ldy	#664
	sty	0,z
	ldd	#577
	jsr	_muldiv

	ais	#+2
	pulm	z
	rts

	align	1
_mph_to_kmh
	pshm	z
	ais	#-2
	tsz

	ldy	#1006
	sty	0,z
	ldd	#1619
	jsr	_muldiv

	ais	#+2
	pulm	z
	rts


	section	.bss
Lmark.18
	ds.b	4
Lold.19
	ds.b	4

	section	.text
	align	1
_anemometer
	pshm	z
	ais	#-18
	tsz

	ste	4,z
	tze	
	jsr	_read_pulsacc
	ste	10,z
	std	12,z
	ldd	2+10,z
	subd	2+Lold.19
	std	2+6,z
	ldd	0+10,z
	sbcb	1+Lold.19
	sbca	0+Lold.19
	std	0+6,z
	ldd	2+6,z
	addd	2+Lold.19
	std	2+14,z
	ldd	0+6,z
	adcb	1+Lold.19
	adca	0+Lold.19
	std	0+14,z
	ldy	14,z
	sty	Lold.19
	ldx	16,z
	stx	Lold.19+2
	tstw	6,z
	bls	L38
	
	clrw	6,z
	ldy	#65535
	sty	8,z

L38	ldy	8,z
	ldx	4,z
	sty	0,x
	ldd	2+0,z
	subd	2+Lmark.18
	std	2+6,z
	ldd	0+0,z
	sbcb	1+Lmark.18
	sbca	0+Lmark.18
	std	0+6,z
	ldx	0,z
	stx	Lmark.18
	ldy	2,z
	sty	Lmark.18+2
	tstw	6,z
	bls	L40
	
	clrw	6,z
	clrw	8,z

L40	ldd	8,z

	ais	#+18
	pulm	z
	rts


	section	.data
	align	1
_vane_to_deg
	dc.w	0
	dc.w	6
	dc.w	17
	dc.w	11
	dc.w	39
	dc.w	34
	dc.w	23
	dc.w	28
	dc.w	84
	dc.w	79
	dc.w	68
	dc.w	73
	dc.w	45
	dc.w	51
	dc.w	62
	dc.w	56
	dc.w	174
	dc.w	169
	dc.w	158
	dc.w	163
	dc.w	135
	dc.w	141
	dc.w	152
	dc.w	146
	dc.w	90
	dc.w	96
	dc.w	107
	dc.w	101
	dc.w	129
	dc.w	124
	dc.w	113
	dc.w	118
	dc.w	354
	dc.w	349
	dc.w	338
	dc.w	343
	dc.w	315
	dc.w	321
	dc.w	332
	dc.w	326
	dc.w	270
	dc.w	276
	dc.w	287
	dc.w	281
	dc.w	309
	dc.w	304
	dc.w	293
	dc.w	298
	dc.w	180
	dc.w	186
	dc.w	197
	dc.w	191
	dc.w	219
	dc.w	214
	dc.w	203
	dc.w	208
	dc.w	264
	dc.w	259
	dc.w	248
	dc.w	253
	dc.w	225
	dc.w	231
	dc.w	242
	dc.w	236

LC0	dc.b	077h,078h,020h,000h

	align	1	; ASM_OUTPUT_ASCII
LC1	dc.b	0B0h,020h,020h,000h

	align	1	; ASM_OUTPUT_ASCII
LC2	dc.b	020h,06Bh,06Dh,02Fh,068h,020h,020h,000h

	align	1	; ASM_OUTPUT_ASCII
LC3	dc.b	0B0h,043h,020h,020h,000h

	align	1	; ASM_OUTPUT_ASCII
LC4	dc.b	025h,000h

	align	1	; ASM_OUTPUT_ASCII
	section	.text
	align	1
_weather_station
	pshm	z
	ais	#-10
	tsz

	tze	
	aie	#2
	jsr	_anemometer
	std	4,z
	lbeq	L42
	
	jsr	_windvane
	tde	
	asle	
	tey	
	xgdy	
	addd	#_vane_to_deg
	xgdy	
	lde	0,y
	tey	
	xgdy	
	addd	_cfg+968
	xgdy	
	lde	#360
	tyd	
	tex	
	idiv	
	std	8,z
	lde	2,z
	ldy	_cfg+842
	ldd	4,z
	std	0,z
	tyd	
	jsr	_muldiv
	tde	
	ldy	#10
	tyx	
	idiv	
	stx	6,z
	ldy	2,z
	stx	0,z
	lde	8,z
	tyd	
	jsr	_log_wind_sample
	tst	_cfg+970
	beq	L42
	
	lde	#LC0
	jsr	_print_string
	lde	8,z
	jsr	_print_short
	lde	#LC1
	jsr	_print_string
	lde	6,z
	jsr	_mph_to_kmh
	tde	
	jsr	_print_short
	lde	#LC2
	jsr	_print_string
	jsr	_ow_celsius
	tde	
	jsr	_print_signed_short
	lde	#LC3
	jsr	_print_string
	jsr	_relative_humidity
	tde	
	jsr	_print_short
	lde	#LC4
	jsr	_print_string
	jsr	_eol

L42
	ais	#+10
	pulm	z
	rts

	align	1

	global	_encode_weather_ascii
_encode_weather_ascii
	pshm	z
	ais	#-12
	tsz

	ste	2,z
	jsr	_winddir
	std	4,z
	jsr	_windspeed
	tde	
	jsr	_mph_to_knots
	tde	
	ste	0,z
	lde	2,z
	ldd	4,z
	jsr	_add_cse_spd
	std	6,z
	ldab	#103
	ldy	6,z
	stab	0,y
	xgdy	
	addd	#1
	xgdy	
	sty	8,z
	jsr	_windgust
	tdx	
	lde	8,z
	jsr	_sprint_03u
	ldab	#116
	ldy	6,z
	stab	4,y
	xgdy	
	addd	#5
	xgdy	
	sty	10,z
	jsr	_ow_fahrenheit
	tdx	
	lde	10,z
	jsr	_sprint_03d_signed
	ldy	6,z
	xgdy	
	addd	#8
	xgdy	
	sty	2,z
	jsr	_relative_humidity
	tdx	
	lde	2,z
	jsr	_sprint_03u
	ldab	#104
	ldy	2,z
	stab	0,y
	ldy	6,z
	xgdy	
	addd	#11
	xgdy	
	sty	2,z
	ldd	2,z

	ais	#+12
	pulm	z
	rts


	section	.bss
Lwx_mark.26
	ds.b	4

	section	.text
	align	1

	global	_weather_run
_weather_run
	pshm	z
	tsz

	lde	Lwx_mark.26
	ldd	Lwx_mark.26+2
	jsr	_time_past
	tstb	
	beq	L47
	
	lde	#Lwx_mark.26
	ldd	#10
	jsr	_future_sec
	jsr	_ow_round
	jsr	_weather_station

L47	pulm	z
	rts


	section	.bss
_veclog
	ds.b	48
_speedlog
	ds.b	60


	end
